#include <stdio.h>
#include <stdbool.h>

typedef struct plants {
    bool is_watered;
    double height; // height in meters
    int num_leaves;
} plant_t;

void initialize_oak_tree(plant_t* plant) {
    // parentheses are necessary here
    (*plant).is_watered = true;
    (*plant).height = 10;
    (*plant).num_leaves = 100000;
}

void initialize_daffodil(plant_t* plant) {
    // Note: struct->field means exactly the same thing as (*struct).field
    plant->is_watered = true;
    plant->height = 0.3;
    plant->num_leaves = 2;
}

void print_plant(plant_t* plant) {
    // Note: struct->field means exactly the same thing as (*struct).field
    // Note: "string a " "string b" is equivalent to "string a string b"
    printf("My plant is %f meters tall "
            "and has %d leaves.\n",
            plant->height, plant->num_leaves);

    if (plant->is_watered) {
        printf("\tIt is watered.\n");
    } else {
        printf("\tIt needs to be watered!!!\n");
    }
}

int main(void) {
    plant_t plant_a;
    plant_t plant_b;

    initialize_oak_tree(&plant_a);
    initialize_daffodil(&plant_b);

    print_plant(&plant_a);
    print_plant(&plant_b);

    return 0;
}


